// OggPlay.h: COggPlay NX̃C^[tFCX
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_OGGPLAY_H__A27B46CD_7CE0_4DD0_8258_631DAAE78535__INCLUDED_)
#define AFX_OGGPLAY_H__A27B46CD_7CE0_4DD0_8258_631DAAE78535__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include <vorbis/codec.h>
#include <vorbis/vorbisfile.h>

/* WAVEt@C̃wb_ */
typedef struct{
	char ckidRIFF[4];
	int ckSizeRIFF;
	char fccType[4];
	char ckidFmt[4];
	int ckSizeFmt;
	WAVEFORMATEX WaveFmt;
	char ckidData[4];
	int ckSizeData;
} WAVEFILEHEADER;

#define BUFSZ			8192
#define OUTPUT_BUFFER_NUM   10
#define OUTPUT_BUFFER_SIZE  BUFSZ

class COggPlay  
{
public:
	COggPlay();
	virtual ~COggPlay();

	void Play(CString fname,double FadeSpeed=0.0);//Đ FadeSpeed>=1.0 0.0or1.0FadeIn OFF
	void stop(double FadeSpeed=0.0);//~ FadeSpeed>=1.0 0.0or1.0FadeOut OFF
	void Pause(BOOL f);
	void ReStart(double FadeSpeed=0.0);
	void Loop(BOOL f){ endf=f^1; }
	BOOL GetLoop() {return endf^1; };
	void GetTime(int &mm,int &ss,int &sss);

	int stf;//vCtO 0:t 1:~
	
protected:	
	long LoadOggVorbis(const char *file_name, int word, char **ogg);
	void ReleaseOggVorbis(char **ogg);
	static VOID CALLBACK waveOutProc(HWAVEOUT hwo,UINT uMsg, DWORD dwInstance, DWORD dwParam1, DWORD dwParam2);
	BOOL AllocOutputBuffer();
	void FreeOutputBuffer(void);
	void playwav();
	int mcopy(char* a,int len,BOOL seek=FALSE,ogg_int64_t pos=0);

	WAVEFILEHEADER wh;
	WAVEFORMATEX wfx;
	char *ogg;
	OggVorbis_File vf;
	long whsize;
	int cc1,t,oggsize,dd,oggsize1,oggsize2,loop1,loop2;
	int lo,loc,endf,locs;
	int playl,ru2,ru;
	int poss,loopcnt,pl_no;
	int current_section;
	int plf,fademode;
	double FadeSpeed_,FadeSpeedt_;
	CString fname_;

	CSemaphore	m_Smp;
	MMRESULT    mmRes;
	HWAVEOUT    hwo;

	char bufwav[OUTPUT_BUFFER_SIZE+5000];
	char buf[OUTPUT_BUFFER_NUM][OUTPUT_BUFFER_SIZE];
	LPWAVEHDR  g_OutputBuffer[OUTPUT_BUFFER_NUM];
};

#endif // !defined(AFX_OGGPLAY_H__A27B46CD_7CE0_4DD0_8258_631DAAE78535__INCLUDED_)
